/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.identitytoolkit.model;

import com.google.api.client.json.GenericJson;
import com.google.api.client.json.JsonString;

/**
 * Request of getting a code for user confirmation (reset password, change email etc.) Request of
 * verifying the password. Response of getting a code for user confirmation (reset password, change
 * email etc.). Respone of setting the account information. Response of verifying the IDP assertion.
 * Respone of uploading accounts in batch. Response of resetting the password. Response of creating
 * the IDP authentication URL. Respone of deleting account. Response of getting account information.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google Identity Toolkit API. For a detailed
 * explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class Relyingparty extends GenericJson {

  /**
   * The action code.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String action;

  /**
   * The URI used by the IDP to authenticate the user.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String authUri;

  /**
   * The recaptcha response from the user.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String captchaResp;

  /**
   * The recaptcha challenge presented to the user.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String challenge;

  /**
   * The opaque value used by the client to maintain context info between the authentication request
   * and the IDP callback.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String context;

  /**
   * The birth date of the IdP account.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String dateOfBirth;

  /**
   * The display name of the user. The name of the user.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String displayName;

  /**
   * The email of the user. The email returned by the IdP. NOTE: The federated login user may not
   * own the email. The user's email.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String email;

  /**
   * It's true if the email is recycled.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Boolean emailRecycled;

  /**
   * The value is true if the IDP is also the email provider. It means the user owns the email.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Boolean emailVerified;

  /**
   * The error encountered while processing the account info.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<Error> error;

  static {
    // hack to force ProGuard to consider Error used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(Error.class);
  }

  /**
   * The unique ID identifies the IdP account.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String federatedId;

  /**
   * The first name of the user.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String firstName;

  /**
   * The full name of the user.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String fullName;

  /**
   * The GITKit token for authenticated user. The user's Gitkit login token for email change. The ID
   * token.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String idToken;

  /**
   * It's the identifier param in the createAuthUri request if the identifier is an email. It can be
   * used to check whether the user input email is different from the asserted email.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String inputEmail;

  /**
   * The fixed string "identitytoolkit#relyingparty". The fixed string
   * identitytoolkit#relyingparty".
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String kind;

  /**
   * The language preference of the user.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String language;

  /**
   * The last name of the user.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String lastName;

  /**
   * The RP local ID if it's already been mapped to the IdP account identified by the federated ID.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String localId;

  /**
   * The new email if the code is for email change.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String newEmail;

  /**
   * The nick name of the user.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String nickName;

  /**
   * The user approved request token for the OpenID OAuth extension.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String oauthRequestToken;

  /**
   * The scope for the OpenID OAuth extension.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String oauthScope;

  /**
   * The code to be send to the user.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String oobCode;

  /**
   * The original email stored in the mapping storage. It's returned when the federated ID is
   * associated to a different email.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String originalEmail;

  /**
   * The URI of the public accessible profiel picture.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String photoUrl;

  /**
   * The associated IDPs of the user.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<String> provider;

  /**
   * The IdP ID. For white listed IdPs it's a short domain name e.g. google.com, aol.com, live.net
   * and yahoo.com. If the "providerId" param is set to OpenID OP identifer other than the whilte
   * listed IdPs the OP identifier is returned. If the "identifier" param is federated ID in the
   * createAuthUri request. The domain part of the federated ID is returned.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String providerId;

  /**
   * Existing IDP's for the user.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<String> providers;

  /**
   * Whether the email is registered. Whether the user is registered if the identifier is an email.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Boolean registered;

  /**
   * The request type.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String requestType;

  /**
   * The timezone of the user.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String timeZone;

  /**
   * The IP address of the user.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String userIp;

  /**
   * The info of the users.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<Users> users;

  static {
    // hack to force ProGuard to consider Users used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(Users.class);
  }

  /**
   * When action is 'map', contains the idps which can be used for confirmation.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<String> verifiedProvider;

  /**
   * The action code.
   * The value returned may be {@code null}.
   */
  public String getAction() {
    return action;
  }

  /**
   * The action code.
   * The value set may be {@code null}.
   */
  public Relyingparty setAction(String action) {
    this.action = action;
    return this;
  }

  /**
   * The URI used by the IDP to authenticate the user.
   * The value returned may be {@code null}.
   */
  public String getAuthUri() {
    return authUri;
  }

  /**
   * The URI used by the IDP to authenticate the user.
   * The value set may be {@code null}.
   */
  public Relyingparty setAuthUri(String authUri) {
    this.authUri = authUri;
    return this;
  }

  /**
   * The recaptcha response from the user.
   * The value returned may be {@code null}.
   */
  public String getCaptchaResp() {
    return captchaResp;
  }

  /**
   * The recaptcha response from the user.
   * The value set may be {@code null}.
   */
  public Relyingparty setCaptchaResp(String captchaResp) {
    this.captchaResp = captchaResp;
    return this;
  }

  /**
   * The recaptcha challenge presented to the user.
   * The value returned may be {@code null}.
   */
  public String getChallenge() {
    return challenge;
  }

  /**
   * The recaptcha challenge presented to the user.
   * The value set may be {@code null}.
   */
  public Relyingparty setChallenge(String challenge) {
    this.challenge = challenge;
    return this;
  }

  /**
   * The opaque value used by the client to maintain context info between the authentication request
   * and the IDP callback.
   * The value returned may be {@code null}.
   */
  public String getContext() {
    return context;
  }

  /**
   * The opaque value used by the client to maintain context info between the authentication request
   * and the IDP callback.
   * The value set may be {@code null}.
   */
  public Relyingparty setContext(String context) {
    this.context = context;
    return this;
  }

  /**
   * The birth date of the IdP account.
   * The value returned may be {@code null}.
   */
  public String getDateOfBirth() {
    return dateOfBirth;
  }

  /**
   * The birth date of the IdP account.
   * The value set may be {@code null}.
   */
  public Relyingparty setDateOfBirth(String dateOfBirth) {
    this.dateOfBirth = dateOfBirth;
    return this;
  }

  /**
   * The display name of the user. The name of the user.
   * The value returned may be {@code null}.
   */
  public String getDisplayName() {
    return displayName;
  }

  /**
   * The display name of the user. The name of the user.
   * The value set may be {@code null}.
   */
  public Relyingparty setDisplayName(String displayName) {
    this.displayName = displayName;
    return this;
  }

  /**
   * The email of the user. The email returned by the IdP. NOTE: The federated login user may not
   * own the email. The user's email.
   * The value returned may be {@code null}.
   */
  public String getEmail() {
    return email;
  }

  /**
   * The email of the user. The email returned by the IdP. NOTE: The federated login user may not
   * own the email. The user's email.
   * The value set may be {@code null}.
   */
  public Relyingparty setEmail(String email) {
    this.email = email;
    return this;
  }

  /**
   * It's true if the email is recycled.
   * The value returned may be {@code null}.
   */
  public Boolean getEmailRecycled() {
    return emailRecycled;
  }

  /**
   * It's true if the email is recycled.
   * The value set may be {@code null}.
   */
  public Relyingparty setEmailRecycled(Boolean emailRecycled) {
    this.emailRecycled = emailRecycled;
    return this;
  }

  /**
   * The value is true if the IDP is also the email provider. It means the user owns the email.
   * The value returned may be {@code null}.
   */
  public Boolean getEmailVerified() {
    return emailVerified;
  }

  /**
   * The value is true if the IDP is also the email provider. It means the user owns the email.
   * The value set may be {@code null}.
   */
  public Relyingparty setEmailVerified(Boolean emailVerified) {
    this.emailVerified = emailVerified;
    return this;
  }

  /**
   * The error encountered while processing the account info.
   * The value returned may be {@code null}.
   */
  public java.util.List<Error> getError() {
    return error;
  }

  /**
   * The error encountered while processing the account info.
   * The value set may be {@code null}.
   */
  public Relyingparty setError(java.util.List<Error> error) {
    this.error = error;
    return this;
  }

  /**
   * The unique ID identifies the IdP account.
   * The value returned may be {@code null}.
   */
  public String getFederatedId() {
    return federatedId;
  }

  /**
   * The unique ID identifies the IdP account.
   * The value set may be {@code null}.
   */
  public Relyingparty setFederatedId(String federatedId) {
    this.federatedId = federatedId;
    return this;
  }

  /**
   * The first name of the user.
   * The value returned may be {@code null}.
   */
  public String getFirstName() {
    return firstName;
  }

  /**
   * The first name of the user.
   * The value set may be {@code null}.
   */
  public Relyingparty setFirstName(String firstName) {
    this.firstName = firstName;
    return this;
  }

  /**
   * The full name of the user.
   * The value returned may be {@code null}.
   */
  public String getFullName() {
    return fullName;
  }

  /**
   * The full name of the user.
   * The value set may be {@code null}.
   */
  public Relyingparty setFullName(String fullName) {
    this.fullName = fullName;
    return this;
  }

  /**
   * The GITKit token for authenticated user. The user's Gitkit login token for email change. The ID
   * token.
   * The value returned may be {@code null}.
   */
  public String getIdToken() {
    return idToken;
  }

  /**
   * The GITKit token for authenticated user. The user's Gitkit login token for email change. The ID
   * token.
   * The value set may be {@code null}.
   */
  public Relyingparty setIdToken(String idToken) {
    this.idToken = idToken;
    return this;
  }

  /**
   * It's the identifier param in the createAuthUri request if the identifier is an email. It can be
   * used to check whether the user input email is different from the asserted email.
   * The value returned may be {@code null}.
   */
  public String getInputEmail() {
    return inputEmail;
  }

  /**
   * It's the identifier param in the createAuthUri request if the identifier is an email. It can be
   * used to check whether the user input email is different from the asserted email.
   * The value set may be {@code null}.
   */
  public Relyingparty setInputEmail(String inputEmail) {
    this.inputEmail = inputEmail;
    return this;
  }

  /**
   * The fixed string "identitytoolkit#relyingparty". The fixed string
   * identitytoolkit#relyingparty".
   * The value returned may be {@code null}.
   */
  public String getKind() {
    return kind;
  }

  /**
   * The fixed string "identitytoolkit#relyingparty". The fixed string
   * identitytoolkit#relyingparty".
   * The value set may be {@code null}.
   */
  public Relyingparty setKind(String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * The language preference of the user.
   * The value returned may be {@code null}.
   */
  public String getLanguage() {
    return language;
  }

  /**
   * The language preference of the user.
   * The value set may be {@code null}.
   */
  public Relyingparty setLanguage(String language) {
    this.language = language;
    return this;
  }

  /**
   * The last name of the user.
   * The value returned may be {@code null}.
   */
  public String getLastName() {
    return lastName;
  }

  /**
   * The last name of the user.
   * The value set may be {@code null}.
   */
  public Relyingparty setLastName(String lastName) {
    this.lastName = lastName;
    return this;
  }

  /**
   * The RP local ID if it's already been mapped to the IdP account identified by the federated ID.
   * The value returned may be {@code null}.
   */
  public String getLocalId() {
    return localId;
  }

  /**
   * The RP local ID if it's already been mapped to the IdP account identified by the federated ID.
   * The value set may be {@code null}.
   */
  public Relyingparty setLocalId(String localId) {
    this.localId = localId;
    return this;
  }

  /**
   * The new email if the code is for email change.
   * The value returned may be {@code null}.
   */
  public String getNewEmail() {
    return newEmail;
  }

  /**
   * The new email if the code is for email change.
   * The value set may be {@code null}.
   */
  public Relyingparty setNewEmail(String newEmail) {
    this.newEmail = newEmail;
    return this;
  }

  /**
   * The nick name of the user.
   * The value returned may be {@code null}.
   */
  public String getNickName() {
    return nickName;
  }

  /**
   * The nick name of the user.
   * The value set may be {@code null}.
   */
  public Relyingparty setNickName(String nickName) {
    this.nickName = nickName;
    return this;
  }

  /**
   * The user approved request token for the OpenID OAuth extension.
   * The value returned may be {@code null}.
   */
  public String getOauthRequestToken() {
    return oauthRequestToken;
  }

  /**
   * The user approved request token for the OpenID OAuth extension.
   * The value set may be {@code null}.
   */
  public Relyingparty setOauthRequestToken(String oauthRequestToken) {
    this.oauthRequestToken = oauthRequestToken;
    return this;
  }

  /**
   * The scope for the OpenID OAuth extension.
   * The value returned may be {@code null}.
   */
  public String getOauthScope() {
    return oauthScope;
  }

  /**
   * The scope for the OpenID OAuth extension.
   * The value set may be {@code null}.
   */
  public Relyingparty setOauthScope(String oauthScope) {
    this.oauthScope = oauthScope;
    return this;
  }

  /**
   * The code to be send to the user.
   * The value returned may be {@code null}.
   */
  public String getOobCode() {
    return oobCode;
  }

  /**
   * The code to be send to the user.
   * The value set may be {@code null}.
   */
  public Relyingparty setOobCode(String oobCode) {
    this.oobCode = oobCode;
    return this;
  }

  /**
   * The original email stored in the mapping storage. It's returned when the federated ID is
   * associated to a different email.
   * The value returned may be {@code null}.
   */
  public String getOriginalEmail() {
    return originalEmail;
  }

  /**
   * The original email stored in the mapping storage. It's returned when the federated ID is
   * associated to a different email.
   * The value set may be {@code null}.
   */
  public Relyingparty setOriginalEmail(String originalEmail) {
    this.originalEmail = originalEmail;
    return this;
  }

  /**
   * The URI of the public accessible profiel picture.
   * The value returned may be {@code null}.
   */
  public String getPhotoUrl() {
    return photoUrl;
  }

  /**
   * The URI of the public accessible profiel picture.
   * The value set may be {@code null}.
   */
  public Relyingparty setPhotoUrl(String photoUrl) {
    this.photoUrl = photoUrl;
    return this;
  }

  /**
   * The associated IDPs of the user.
   * The value returned may be {@code null}.
   */
  public java.util.List<String> getProvider() {
    return provider;
  }

  /**
   * The associated IDPs of the user.
   * The value set may be {@code null}.
   */
  public Relyingparty setProvider(java.util.List<String> provider) {
    this.provider = provider;
    return this;
  }

  /**
   * The IdP ID. For white listed IdPs it's a short domain name e.g. google.com, aol.com, live.net
   * and yahoo.com. If the "providerId" param is set to OpenID OP identifer other than the whilte
   * listed IdPs the OP identifier is returned. If the "identifier" param is federated ID in the
   * createAuthUri request. The domain part of the federated ID is returned.
   * The value returned may be {@code null}.
   */
  public String getProviderId() {
    return providerId;
  }

  /**
   * The IdP ID. For white listed IdPs it's a short domain name e.g. google.com, aol.com, live.net
   * and yahoo.com. If the "providerId" param is set to OpenID OP identifer other than the whilte
   * listed IdPs the OP identifier is returned. If the "identifier" param is federated ID in the
   * createAuthUri request. The domain part of the federated ID is returned.
   * The value set may be {@code null}.
   */
  public Relyingparty setProviderId(String providerId) {
    this.providerId = providerId;
    return this;
  }

  /**
   * Existing IDP's for the user.
   * The value returned may be {@code null}.
   */
  public java.util.List<String> getProviders() {
    return providers;
  }

  /**
   * Existing IDP's for the user.
   * The value set may be {@code null}.
   */
  public Relyingparty setProviders(java.util.List<String> providers) {
    this.providers = providers;
    return this;
  }

  /**
   * Whether the email is registered. Whether the user is registered if the identifier is an email.
   * The value returned may be {@code null}.
   */
  public Boolean getRegistered() {
    return registered;
  }

  /**
   * Whether the email is registered. Whether the user is registered if the identifier is an email.
   * The value set may be {@code null}.
   */
  public Relyingparty setRegistered(Boolean registered) {
    this.registered = registered;
    return this;
  }

  /**
   * The request type.
   * The value returned may be {@code null}.
   */
  public String getRequestType() {
    return requestType;
  }

  /**
   * The request type.
   * The value set may be {@code null}.
   */
  public Relyingparty setRequestType(String requestType) {
    this.requestType = requestType;
    return this;
  }

  /**
   * The timezone of the user.
   * The value returned may be {@code null}.
   */
  public String getTimeZone() {
    return timeZone;
  }

  /**
   * The timezone of the user.
   * The value set may be {@code null}.
   */
  public Relyingparty setTimeZone(String timeZone) {
    this.timeZone = timeZone;
    return this;
  }

  /**
   * The IP address of the user.
   * The value returned may be {@code null}.
   */
  public String getUserIp() {
    return userIp;
  }

  /**
   * The IP address of the user.
   * The value set may be {@code null}.
   */
  public Relyingparty setUserIp(String userIp) {
    this.userIp = userIp;
    return this;
  }

  /**
   * The info of the users.
   * The value returned may be {@code null}.
   */
  public java.util.List<Users> getUsers() {
    return users;
  }

  /**
   * The info of the users.
   * The value set may be {@code null}.
   */
  public Relyingparty setUsers(java.util.List<Users> users) {
    this.users = users;
    return this;
  }

  /**
   * When action is 'map', contains the idps which can be used for confirmation.
   * The value returned may be {@code null}.
   */
  public java.util.List<String> getVerifiedProvider() {
    return verifiedProvider;
  }

  /**
   * When action is 'map', contains the idps which can be used for confirmation.
   * The value set may be {@code null}.
   */
  public Relyingparty setVerifiedProvider(java.util.List<String> verifiedProvider) {
    this.verifiedProvider = verifiedProvider;
    return this;
  }

  /**
   * Model definition for RelyingpartyError.
   */
  public static final class Error extends GenericJson {

    /**
     * The index of the malformed account, starting from 0.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private Integer index;

    /**
     * Detailed error message for the account info.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private String message;

    /**
     * The index of the malformed account, starting from 0.
     * The value returned may be {@code null}.
     */
    public Integer getIndex() {
      return index;
    }

    /**
     * The index of the malformed account, starting from 0.
     * The value set may be {@code null}.
     */
    public Error setIndex(Integer index) {
      this.index = index;
      return this;
    }

    /**
     * Detailed error message for the account info.
     * The value returned may be {@code null}.
     */
    public String getMessage() {
      return message;
    }

    /**
     * Detailed error message for the account info.
     * The value set may be {@code null}.
     */
    public Error setMessage(String message) {
      this.message = message;
      return this;
    }

  }

  /**
   * Model definition for RelyingpartyUsers.
   */
  public static final class Users extends GenericJson {

    /**
     * The user's date of birth.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private String dateOfBirth;

    /**
     * The name of the user.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private String displayName;

    /**
     * The email returned by the IdP. NOTE: The federated login user may not own the email.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private String email;

    /**
     * The language of the user.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private String language;

    /**
     * The local ID of the user.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private String localId;

    /**
     * The user's hashed password.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private String password;

    /**
     * The timestamp when the password was last updated.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key @JsonString
    private Long passwordUpdatedAt;

    /**
     * The URL of the user profile photo.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private String photoUrl;

    /**
     * The IDP of the user.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.util.List<String> provider;

    /**
     * The user's password salt.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private String salt;

    /**
     * The time zone of the user.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private String timeZone;

    /**
     * Version of the user's password.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private Integer version;

    /**
     * The user's date of birth.
     * The value returned may be {@code null}.
     */
    public String getDateOfBirth() {
      return dateOfBirth;
    }

    /**
     * The user's date of birth.
     * The value set may be {@code null}.
     */
    public Users setDateOfBirth(String dateOfBirth) {
      this.dateOfBirth = dateOfBirth;
      return this;
    }

    /**
     * The name of the user.
     * The value returned may be {@code null}.
     */
    public String getDisplayName() {
      return displayName;
    }

    /**
     * The name of the user.
     * The value set may be {@code null}.
     */
    public Users setDisplayName(String displayName) {
      this.displayName = displayName;
      return this;
    }

    /**
     * The email returned by the IdP. NOTE: The federated login user may not own the email.
     * The value returned may be {@code null}.
     */
    public String getEmail() {
      return email;
    }

    /**
     * The email returned by the IdP. NOTE: The federated login user may not own the email.
     * The value set may be {@code null}.
     */
    public Users setEmail(String email) {
      this.email = email;
      return this;
    }

    /**
     * The language of the user.
     * The value returned may be {@code null}.
     */
    public String getLanguage() {
      return language;
    }

    /**
     * The language of the user.
     * The value set may be {@code null}.
     */
    public Users setLanguage(String language) {
      this.language = language;
      return this;
    }

    /**
     * The local ID of the user.
     * The value returned may be {@code null}.
     */
    public String getLocalId() {
      return localId;
    }

    /**
     * The local ID of the user.
     * The value set may be {@code null}.
     */
    public Users setLocalId(String localId) {
      this.localId = localId;
      return this;
    }

    /**
     * The user's hashed password.
     * The value returned may be {@code null}.
     */
    public String getPassword() {
      return password;
    }

    /**
     * The user's hashed password.
     * The value set may be {@code null}.
     */
    public Users setPassword(String password) {
      this.password = password;
      return this;
    }

    /**
     * The timestamp when the password was last updated.
     * The value returned may be {@code null}.
     */
    public Long getPasswordUpdatedAt() {
      return passwordUpdatedAt;
    }

    /**
     * The timestamp when the password was last updated.
     * The value set may be {@code null}.
     */
    public Users setPasswordUpdatedAt(Long passwordUpdatedAt) {
      this.passwordUpdatedAt = passwordUpdatedAt;
      return this;
    }

    /**
     * The URL of the user profile photo.
     * The value returned may be {@code null}.
     */
    public String getPhotoUrl() {
      return photoUrl;
    }

    /**
     * The URL of the user profile photo.
     * The value set may be {@code null}.
     */
    public Users setPhotoUrl(String photoUrl) {
      this.photoUrl = photoUrl;
      return this;
    }

    /**
     * The IDP of the user.
     * The value returned may be {@code null}.
     */
    public java.util.List<String> getProvider() {
      return provider;
    }

    /**
     * The IDP of the user.
     * The value set may be {@code null}.
     */
    public Users setProvider(java.util.List<String> provider) {
      this.provider = provider;
      return this;
    }

    /**
     * The user's password salt.
     * The value returned may be {@code null}.
     */
    public String getSalt() {
      return salt;
    }

    /**
     * The user's password salt.
     * The value set may be {@code null}.
     */
    public Users setSalt(String salt) {
      this.salt = salt;
      return this;
    }

    /**
     * The time zone of the user.
     * The value returned may be {@code null}.
     */
    public String getTimeZone() {
      return timeZone;
    }

    /**
     * The time zone of the user.
     * The value set may be {@code null}.
     */
    public Users setTimeZone(String timeZone) {
      this.timeZone = timeZone;
      return this;
    }

    /**
     * Version of the user's password.
     * The value returned may be {@code null}.
     */
    public Integer getVersion() {
      return version;
    }

    /**
     * Version of the user's password.
     * The value set may be {@code null}.
     */
    public Users setVersion(Integer version) {
      this.version = version;
      return this;
    }

  }

}
